
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Price_listsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const price_lists = await db.price_lists.create(
            {
                id: data.id || undefined,
        
        price_list_name: data.price_list_name
        ||
        null
            ,
            
        price_list_type: data.price_list_type
        ||
        null
            ,
            
        effective_start: data.effective_start
        ||
        null
            ,
            
        effective_end: data.effective_end
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return price_lists;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const price_listsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                price_list_name: item.price_list_name
            ||
            null
            ,
            
                price_list_type: item.price_list_type
            ||
            null
            ,
            
                effective_start: item.effective_start
            ||
            null
            ,
            
                effective_end: item.effective_end
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const price_lists = await db.price_lists.bulkCreate(price_listsData, { transaction });

        // For each item created, replace relation files
        

        return price_lists;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const price_lists = await db.price_lists.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.price_list_name !== undefined) updatePayload.price_list_name = data.price_list_name;
        
        
        if (data.price_list_type !== undefined) updatePayload.price_list_type = data.price_list_type;
        
        
        if (data.effective_start !== undefined) updatePayload.effective_start = data.effective_start;
        
        
        if (data.effective_end !== undefined) updatePayload.effective_end = data.effective_end;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await price_lists.update(updatePayload, {transaction});

        
        

        
        

        

        return price_lists;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const price_lists = await db.price_lists.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of price_lists) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of price_lists) {
                await record.destroy({transaction});
            }
        });


        return price_lists;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const price_lists = await db.price_lists.findByPk(id, options);

        await price_lists.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await price_lists.destroy({
            transaction
        });

        return price_lists;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const price_lists = await db.price_lists.findOne(
            { where },
            { transaction },
        );

        if (!price_lists) {
            return price_lists;
        }

        const output = price_lists.get({plain: true});

        
        
        
        
        output.accounts_default_price_list = await price_lists.getAccounts_default_price_list({
            transaction
        });
        
        
        
        
        
        
        
        
        output.price_list_items_price_list = await price_lists.getPrice_list_items_price_list({
            transaction
        });
        
        
        output.account_price_lists_price_list = await price_lists.getAccount_price_lists_price_list({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.price_list_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'price_lists',
                        'price_list_name',
                        filter.price_list_name,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'price_lists',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            effective_start: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    effective_end: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.effective_startRange) {
                const [start, end] = filter.effective_startRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    effective_start: {
                    ...where.effective_start,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    effective_start: {
                    ...where.effective_start,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.effective_endRange) {
                const [start, end] = filter.effective_endRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    effective_end: {
                    ...where.effective_end,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    effective_end: {
                    ...where.effective_end,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.price_list_type) {
                where = {
                    ...where,
                price_list_type: filter.price_list_type,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.price_lists.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'price_lists',
                        'price_list_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.price_lists.findAll({
            attributes: [ 'id', 'price_list_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['price_list_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.price_list_name,
        }));
    }

    
};

